using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_TouchPanel
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont statusFont;
        string statusString;
        SpriteFont touchFont;
        class TouchPoint
        {
            public TouchPoint(Vector2 pos, string str)
            {
                position = pos;
                text = str;
                Random rd = new Random();
                textcolor = new Color(rd.Next(250), rd.Next(250), rd.Next(250));
            }
            public Vector2 position;
            public string text;
            public Color textcolor;
        }
        Dictionary<int, TouchPoint> touchpoints = new Dictionary<int, TouchPoint>();

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            graphics.IsFullScreen = true;
            Content.RootDirectory = "Content";
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            statusFont = Content.Load<SpriteFont>("SpriteFont1");
            touchFont = Content.Load<SpriteFont>("SpriteFont2");
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            //Eigenschaften abfragen
            TouchPanelCapabilities caps = TouchPanel.GetCapabilities();
            //Touchscreen als String
            statusString = "Touchscreen = " + caps.IsConnected.ToString() + "\n";
            //Anzahl der Touchpunkte als String
            statusString += "Touch Punkte = " + caps.MaximumTouchCount.ToString();
            // TODO: Add your update logic here
            TouchCollection Touches = TouchPanel.GetState();
            foreach (TouchLocation location in Touches)
            {
                //Ein neuer Touch
                if (location.State == TouchLocationState.Pressed)
                    touchpoints.Add(location.Id, new TouchPoint(location.Position,"Position"+location.Id.ToString()));
                else if(location.State == TouchLocationState.Released)
                    touchpoints.Remove(location.Id);
                else if(location.State == TouchLocationState.Moved)
                    touchpoints[location.Id].position = location.Position;
                else
                    touchpoints[location.Id].text = "Invalid";
            }
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.White);

            spriteBatch.Begin();

            spriteBatch.DrawString(statusFont, statusString, new Vector2(5, 5), Color.Red);
    
            foreach(KeyValuePair<int,TouchPoint> tp in touchpoints)
            {
                spriteBatch.DrawString(touchFont, tp.Value.text, tp.Value.position, tp.Value.textcolor);
            }
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
